function [] = Amplitude_GenerateData(array_bit_length,samples_per_bit, instances_per_type, modScheme,test_train)
%AMPLITUDE_GENERATEDATA Summary of this function goes here
%   Detailed explanation goes here

numSamples = array_bit_length*samples_per_bit;
shift_number = 0;

numOutputs = 11;

preamble = [];
dataBits = [];

maxdataBits = 50;
startPosition = 1;
ampRatio = 0;
SNR = 6;
periods = 1;
scew = 0;

XTrain = zeros(numSamples,1,1,instances_per_type*numOutputs);
YTrain = {};

amplitudes = [0 5 10 15 20 25 30 35 40 45 50];

for amp_index = 1:length(amplitudes)
    for iteration =1:instances_per_type
        startPosition = randi([1 array_bit_length]);
        maxBits = (numSamples-startPosition+1);
        if maxBits > maxdataBits
            maxBits = maxdataBits;
        end
        numdataBits = randi([1 maxBits], 1);
        dataBits = randi([0 1], numdataBits,1);
        if modScheme == "ASK"
            if sum(dataBits) == 0
                dataBits(1) = 1;
            end
        end
        scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
        
        if startPosition == array_bit_length
            shift_number = 1;
        else
            shift_number = randi([1, samples_per_bit-1]);
        end

        if amplitudes(amp_index) == 0
            ampIt = 0;
        else
            ampIt = (amplitudes(amp_index))/100; %+ (randi([-100 100],1)/100)/100;
        end
       
        %instance = generate_RVM_signal2(modScheme,array_bit_length, [], dataBits, startPosition, 50, SNR, samples_per_bit, periods, scew, shift_number);
        instance = generate_RVM_signal3(modScheme,array_bit_length, [], dataBits, startPosition, ampIt, SNR, samples_per_bit, periods, scew, shift_number);
        XTrain(:,1,1,(amp_index-1)*instances_per_type+iteration) = instance(:);
        YTrain = vertcat(YTrain, categorical(amplitudes(amp_index)));
        
    end


if test_train == "train"
    if modScheme == "ASK"
        save('ASK_Amplitude_TrainData','XTrain', 'YTrain');
    elseif modScheme == "FSK"
       save('FSK_Amplitude_TrainData','XTrain', 'YTrain');
    elseif modScheme == "PSK"
        save('PSK_Amplitude_TrainData','XTrain', 'YTrain');
    end           
end

%save('ASK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
%save('FSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
%save('PSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');

XTest = XTrain;
YTest = YTrain;
if test_train == "test"
    if modScheme == "ASK"
        save('ASK_Amplitude_ClassifyData','XTest', 'YTest');
    elseif modScheme == "FSK"
        save('FSK_Amplitude_ClassifyData','XTest', 'YTest');
    elseif modScheme == "PSK"
        save('PSK_Amplitude_ClassifyData','XTest', 'YTest');
    end
end


end
end

