function [outputArg1,outputArg2] = Position_Generate_1BData(samples_per_bit, instances_per_type, modScheme, test_train)
%POSITION_GENERATE_1BDATA Summary of this function goes here
%   Detailed explanation goes here
%Variables that can be changed

array_bit_length = 8;
numSamples = 8*samples_per_bit;


numOutputs = 8;




ampRatio = 0.5;
SNR = -6;
periods = 1;


XTrain = zeros(numSamples,1,1,instances_per_type*numOutputs);
YTrain = {};


for bitN = 1:8
    
    for typeInstance = 1:instances_per_type
        BitPos = bitN;
        bitNumber = randi([1 (8-bitN+1)],1,1);
        dataBitArray = randi([0 1],bitNumber,1);
        if modScheme == "ASK"
            dataBitArray(1) = 1;
        end
        
        shift_number = randi([1, samples_per_bit-1]);
        scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
        
        instance = generate_RVM_signal3(modScheme,array_bit_length, [], dataBitArray, BitPos, ampRatio, SNR, samples_per_bit, periods, scew, shift_number);
        
        XTrain(:,1,1,(bitN-1)*instances_per_type+typeInstance) = instance(:);
        
        yCategory = categorical(bitN);
        YTrain = vertcat(YTrain, yCategory);
    end
end


XTest = XTrain;
YTest = YTrain;
%save('Position_05SNR_ClassifyData_nocat','XTest', 'YTest');


if test_train == "train"
    if modScheme == "ASK"
        save('ASK_Position1B_TrainData','XTrain', 'YTrain');
    elseif modScheme == "FSK"
       save('FSK_Position1B_TrainData','XTrain', 'YTrain');
    elseif modScheme == "PSK"
        save('PSK_Position1B_TrainData','XTrain', 'YTrain');
    end           
end

%save('ASK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
%save('FSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
%save('PSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');

XTest = XTrain;
YTest = YTrain;
if test_train == "test"
    if modScheme == "ASK"
        save('ASK_Position1B_ClassifyData','XTest', 'YTest');
    elseif modScheme == "FSK"
        save('FSK_Position1B_ClassifyData','XTest', 'YTest');
    elseif modScheme == "PSK"
        save('PSK_Position1B_ClassifyData','XTest', 'YTest');
    end
end


end

