function [] = Position_Generate_Data(array_byte_length,samples_per_bit, instances_per_type, modScheme, test_train)
%GENERATE_RVM_DATA Summary of this function goes here
%   Detailed explanation goes here

%generate_RVM_signal(modulation_scheme,array_bit_length,preamble_bits, data_bits, 
%signal_start_index, signal_amplitude, snr, samples_per_bit,periods_per_bit,signal_scew)


%TO RUN PROGRAM: generate_RVM_data(25,8, 200)

%Variables that can be changed
array_bit_length = array_byte_length*8;
numSamples = array_byte_length*8*samples_per_bit;
numLayers = 10;
numBytesPerLayer = array_byte_length / numLayers;
numSamplesPerLayer = numSamples / numLayers;
shift_number = 1;

numOutputs = 10;

preamble = [1 0 1 0 1 0 1 1];
dataBits = [];
maxdataBytes = array_byte_length;
maxdataBits = maxdataBytes*8;
startPosition = 1;
ampRatio = 0.5;
SNR = -6;
periods = 1;
scew = 0;

XTrain = zeros(numSamplesPerLayer,numLayers,1,instances_per_type*numOutputs);
YTrain = {};
typeIndex = 0;
%YTrain = vertcat(YTrain, variable);


for layerNumber=0:numLayers-1
    for typeInstance = 1:instances_per_type
        
        MinBytePos = layerNumber*numBytesPerLayer;
        yCategory = categorical(MinBytePos);
        BitPos = 8*MinBytePos+randi([1 8]);
   
        %BitPosition = (MinBytePos + randi([1 (numBytesPerLayer)]))*8;
        %BitPosition = MinBytePos*8
        
        maxBitLength = maxdataBits;
        if BitPos + maxBitLength > (array_byte_length*8)
            maxBitLength = (array_byte_length*8)-BitPos+1;
            if maxBitLength < 1
                maxBitLength = 1;
            end
        end
        
        
        numDataBits = randi([1 maxdataBits]);
        if numDataBits > maxBitLength
            numDataBits = maxBitLength;
        end
        dataBitArray = randi([0 1],1,numDataBits);
        if modScheme == "ASK"
            dataBitArray(1) = 1;
        end
        shift_number = randi([1, samples_per_bit-1]);
        scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
        
        instance = generate_RVM_signal3(modScheme,array_bit_length, [], dataBitArray, BitPos, ampRatio, SNR, samples_per_bit, periods, scew, shift_number);
        instance = reshape(instance,numSamplesPerLayer,numLayers);
        instance = instance.';
        for yPos=1:numLayers
            XTrain(:,yPos,1,layerNumber*instances_per_type+typeInstance) = instance(yPos,:);
        end
        YTrain = vertcat(YTrain, yCategory);
    end
end

%YTrain = categorical(YTrain);
%save('Position_05SNR_TrainData','XTrain', 'YTrain');

XTest = XTrain;
YTest = YTrain;
%save('Position_05SNR_ClassifyData_nocat','XTest', 'YTest');


if test_train == "train"
    if modScheme == "ASK"
        save('ASK_Position_TrainData','XTrain', 'YTrain');
    elseif modScheme == "FSK"
       save('FSK_Position_TrainData','XTrain', 'YTrain');
    elseif modScheme == "PSK"
        save('PSK_Position_TrainData','XTrain', 'YTrain');
    end           
end

%save('ASK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
%save('FSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
%save('PSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');

XTest = XTrain;
YTest = YTrain;
if test_train == "test"
    if modScheme == "ASK"
        save('ASK_Position_ClassifyData','XTest', 'YTest');
    elseif modScheme == "FSK"
        save('FSK_Position_ClassifyData','XTest', 'YTest');
    elseif modScheme == "PSK"
        save('PSK_Position_ClassifyData','XTest', 'YTest');
    end
end



























%instance = generate_RVM_signal(modScheme,array_bit_length, [1 1], dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
       

%for i =0:numLayers-1
%    yPos = i;
%    xMinPos = i*numSamplesPerLayer;
%    cat = categorical(xMinPos);
%    for j=1:instances_per_type
%        numData = randi([1 maxdataBytes])*8;
%        dataBits = randi([0 1],1,numData);
%        startPosition = (xMinPos + randi([1 (numSamplesPerLayer)]))*8;
%        startPosition = 0;
%        instance = generate_RVM_signal(modScheme,array_bit_length, [1 1 1 1 1 1 1 1], dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
        
%    end
%end





%Output 0: No Preamble, No Data. No signal
%typeIndex = 0;
%for i= 1:instances_per_type
%    instance = generate_RVM_signal(modScheme,array_bit_length, [], [], startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
%    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
%    YTrain = vertcat(YTrain, '0');
%end

%typeIndex = 1;
%for i= 1:instances_per_type
%    numData = randi([1 maxdataBits]);
%    dataBits = randi([0 1],1,numData);
%    dataBits(1) = 1;
%    startPosition = randi([1 array_bit_length-length(dataBits)]);
%    instance = generate_RVM_signal(modScheme,array_bit_length, preamble, dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
%    
%    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
%    YTrain = vertcat(YTrain, '1');
%end





%YTrain = categorical(YTrain);
%save('10B_Position_05SNR_TrainData','XTrain', 'YTrain');

%XTest = XTrain;
%YTest = YTrain;
%save('10B_Position_05SNR_ClassifyData','XTest', 'YTest');
end

